Summary:        High performance J2EE caching solution
Name:           oscache
Version:        2.1.1
Release:        3jpp
Epoch:          0
License:        Apache Software License
URL:            http://www.opensymphony.com/oscache/
Group:          Development/Libraries/Java
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        oscache-2.1.1-full.zip
Source1:        oscache-build.xml
Source2:        oscache-build.properties
Source3:        oscache-jalopy.xml
Source4:        oscache-LICENSE.txt
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  ant >= 0:1.6
BuildRequires:  jalopy
BuildRequires:  ant-jalopy
BuildRequires:  jdom
BuildRequires:  log4j
BuildRequires:  oro
BuildRequires:  junit
BuildRequires:  ant-junit
BuildRequires:  clover10
BuildRequires:  clover-ant
BuildRequires:  junitperf
BuildRequires:  httpunit
BuildRequires:  jms >= 0:1.1
BuildRequires:  servletapi5
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-logging
BuildRequires:  jgroups
Requires:  jms >= 0:1.1
Requires:  jakarta-commons-logging

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
OSCache solves fundamental problems for dynamic websites:
+ Caching Dynamic Content - Dynamic content must often be 
executed in some form each request, but sometimes that 
content doesn't change every request. Caching the whole 
page does not help because sections of the page change 
every request. OSCache solves this problem by providing 
a means to cache sections of JSP pages. 
+ Caching Binary Content - Generated images and PDFs can 
be very costly in terms of server load. OSCache solves 
this problem through a Servlet 2.3 CachingFilter which 
can cache any URI (such as an entire page or a generated 
image/PDF) 
+ Error Tolerance - If one error occurs somewhere on your 
dynamic page, chances are the whole page will be returned 
as an error, even if 95% of the page executed correctly. 
OSCache solves this problem by allowing you to serve the 
cached content in the event of an error, and then 
reporting the error appropriately. 


%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -T -c -n %{name}-%{version}
unzip -q %{SOURCE0}
find . -name "*.jar" -exec rm {} \;
cp %{SOURCE1} build.xml
cp %{SOURCE2} build.properties
mkdir -p src/core/etc
cp %{SOURCE3} src/core/etc/jalopy.xml
cp %{SOURCE4} LICENSE.txt
cp etc/* src/core/etc

%build
export OPT_JAR_LIST="ant/ant-junit junit clover10"
export CLASSPATH=$(build-classpath \
httpunit \
jms \
commons-logging \
servletapi5 \
jspapi \
junitperf)
(cd lib/core
ln -s $(find-jar commons-collections) commons-collections.jar
ln -s $(find-jar commons-logging) commons-logging.jar
)
(cd lib/plugins/clustersupport
ln -s $(find-jar jgroups) jgroups-all.jar
)
mkdir -p lib/build/jalopy
(cd lib/build/jalopy
ln -s $(find-jar jalopy) jalopy.jar
ln -s $(find-jar jalopy-ant) jalopy-ant.jar
ln -s $(find-jar jdom) jdom.jar
ln -s $(find-jar log4j) log4j.jar
ln -s $(find-jar oro) oro.jar
)
ant -Dbuild.sysclasspath=first dist

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p dist/%{name}-%{version}-*.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp etc/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp LICENSE.txt $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf dist/docs/api

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr dist/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p dist/oscache-example.war $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}


%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%{_datadir}/%{name}-%{version}
%{_javadir}

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}

# -----------------------------------------------------------------------------

%changelog
* Thu Jul 14 2005 Ralph Apel <r.apel at r-apel.de> - 0:2.1.1-3jpp
- Bump release to rectify a failed upload

* Sat Jul 09 2005 Ralph Apel <r.apel at r-apel.de> - 0:2.1.1-2jpp
- Return to clover10 as BuildReq
- Get 2.1.1 build.xml, build.properties, LICENSE.txt from CVS
- Replace clover-report by explicit execution of 
  com.cortexeb.tools.clover.reporters.html.HtmlReporter

* Sat May 14 2005 J Desrochers <jdesrochers at users.sourceforge.net> - 0:2.1.1-1jpp
- Update to version 2.1.1

* Mon Sep 27 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0.2-4jpp
- Fix version, continue release
- Relax some versioned dependencies
- Downgrade clover BuildReq to clover10
- Omit clover-report

* Tue Aug 24 2004 Fernando Nasser <fnasser@redhat.com> - 0:2.0.2-3jpp
- Update to version 2.0.2
- Update for servletapi5
- Rebuilt with Ant 1.6.2

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:2.0.1-2jpp
- Upgrade to Ant 1.6.X

* Sat Feb 28 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0.1-1jpp
- First JPackage release
